// tutorial.nut

// ̓`[gAŐNXȂǂ̃R[hɂȂ܂

// -----------------------------------------------------------------------
// ꍀڂ̃`[gA
class ColumnNameEntry extends SpecialEntry {
  constructor() {
    base.constructor( Card.Type.Land - 100, "Column Name", "J", Board.Type.Mainboard );
  }

  function case_of_cannot_process( processor ) {
    return processor.name;
  }
}
::Organizer.special_entries.append( ColumnNameEntry() );


class TotalOfConvertedManaCostIsXEntry extends TotalEntry {
  constructor( cmc, board_type ) {
    local name    = "CMC = " + cmc + " Total";
    local name_jp = "CMC = " + cmc + " v";
    base.constructor( Card.Type.MainTotal + 100, name, name_jp, board_type );
    this.cmc = cmc;
  }

  function should_count( card ) {
    return card.converted_mana_cost == this.cmc;
  }

  cmc = null;
}
::Organizer.special_entries.append( TotalOfConvertedManaCostIsXEntry( 1, Board.Type.Mainboard ) );
::Organizer.special_entries.append( TotalOfConvertedManaCostIsXEntry( 2, Board.Type.Mainboard ) );
::Organizer.special_entries.append( TotalOfConvertedManaCostIsXEntry( 1, Board.Type.Sideboard ) );


class ConvertedManaCostTotalEntry extends TotalEntry {
  constructor( board_type ) {
    base.constructor( Card.Type.MainTotal + 200, "CMC Total", "CMC v", board_type );
  }
  
  // ( Board ̃CX^X ) ߂l integer ̊֐
  function count_total( board ) {
    local sum = 0;
    foreach ( card_name, count in board.table ) {
      sum += ::Organizer.card_database.fetch( card_name ).converted_mana_cost * count;
    }
    return sum;
  }
}
::Organizer.special_entries.append( ConvertedManaCostTotalEntry( Board.Type.Mainboard ) );


// -----------------------------------------------------------------------
// Jƕёւ̃`[gA

::Organizer.calculate_variance_of_decks_by_entry <- function( entry )
{
  local decks_count = decks.len().tofloat();
  if ( entry.card.is_normal() ) {
    if ( decks_count == 0.0 ) {
      return 0.0;
    }

    local average = ::Organizer.get_sum_of_decks_card_count_by_entry( entry ).tofloat() / decks_count;
    return ::Organizer.get_sum_of_decks_board( entry.board_type, function( board ) {
      local tmp = average - board.get_count_of( entry.card );
      return tmp * tmp;
    } ) / decks_count;
  }

  if ( entry instanceof TotalEntry ) {
    if ( decks_count == 0.0 ) {
      return 0.0;
    }

    local average = ::Organizer.get_sum_of_decks_board(
      entry.board_type, @( board ) board.count_total_of( @( card ) entry.should_count( card ) ) ).tofloat() / decks_count;

    return ::Organizer.get_sum_of_decks_board( entry.board_type, function( board ) {
      local tmp = average - board.count_total_of( @( card ) entry.should_count( card ) );
      return tmp * tmp;
    } ) / decks_count;
  }
  return null;
}

::Organizer.calculate_standard_deviation_of_decks_by_entry <- function( entry )
{
  local tmp = ::Organizer.calculate_variance_of_decks_by_entry( entry );
  if ( tmp != null ) {
    return ::sqrt( tmp );
  }
  return tmp;
}


class VarianceProcessor extends Processor {
  constructor() {
    this.name = "U";
    this.sorter = ::VarianceSorter();
  }

  function process_function( entry ) {
    return ::Organizer.calculate_variance_of_decks_by_entry( entry );
  }
}

class VarianceSorter extends Sorter {
  constructor() {
    this.name = "U";
  }

  function compare_for_sort( x, y ) {
    return Sorter.compare_same_board_normal_only( x, y, function( x, y ) {
      local tmp_x = ::Organizer.calculate_variance_of_decks_by_entry( x );
      local tmp_y = ::Organizer.calculate_variance_of_decks_by_entry( y );
      return tmp_y - tmp_x;
    } );
  }
}


class StandardDeviationProcessor extends Processor {
  constructor() {
    this.name = "W΍";
    this.sorter = ::StandardDeviationSorter();
  }

  function process_function( entry ) {
    return ::Organizer.calculate_standard_deviation_of_decks_by_entry( entry );
  }
}

class StandardDeviationSorter extends Sorter {
  constructor() {
    this.name = "W΍";
  }

  function compare_for_sort( x, y ) {
    return Sorter.compare_same_board_normal_only( x, y, function( x, y ) {
      local tmp_x = ::Organizer.calculate_standard_deviation_of_decks_by_entry( x );
      local tmp_y = ::Organizer.calculate_standard_deviation_of_decks_by_entry( y );
      return tmp_y - tmp_x;
    } );
  }
}


::Organizer.processors.append( SubMenu.Separator );
::Organizer.processors.append( ::SubMenu( "v", [
  ::VarianceProcessor(),
  ::StandardDeviationProcessor(),
  ] ) );

::Organizer.sorters.append( SubMenu.Separator );
::Organizer.sorters.append( ::SubMenu( "v", [
  ::VarianceSorter(),
  ::StandardDeviationSorter(),
  ] ) );


/*
// -- Prototype -----
// -- _A[L^Cv̗
// ̂悤ɍ΃A[L^Cv܂Ƃ
class ModernArchetypeInferenceEntry extends SpecialEntry {
  constructor() {
    base.constructor( Card.Type.SideboardStart - 1000, "Modern Archetype Inference", "_A[L^Cv", Board.Type.Mainboard );
  }

  function case_of_cannot_process( processor ) {
    if ( processor instanceof DeckProcessor ) {
      local deck = processor.deck;
      local main = deck.mainboard.table;
      local side = deck.sideboard.table;
      local function main_is_more( name, count ) {
        if ( name in main ) {
          return main[name] >= count;
        }
        return false;
      }

      if ( main_is_more( "Cranial Plating",  4 ) &&
           main_is_more( "Mox Opal",         3 ) &&
           main_is_more( "Vault Skirge",     3 ) &&
           main_is_more( "Arcbound Ravager", 3 ) ) {
        return "ea";
      }
      if ( main_is_more( "Prized Amalgam",      4 ) &&
           main_is_more( "Golgari Grave-Troll", 4 ) ) {
        return "@";
      }
      if ( main_is_more( "Death's Shadow",    4 ) &&
           main_is_more( "Temur Battle Rage", 3 ) &&
           main_is_more( "Become Immense",    3 ) ) {
        return "X[p[NCW[Y[";
      }
      if ( main_is_more( "Liliana of the Veil",    3 ) &&
           main_is_more( "Tarmogoyf",              3 ) &&
           main_is_more( "Inquisition of Kozilek", 2 ) &&
           main_is_more( "Thoughtseize",           2 ) ) {
        if ( main_is_more( "Lightning Bolt", 3 ) ) {
          return "Wh";
        }
        if ( main_is_more( "Lingering Souls", 3 ) ) {
          return "AuUWN";
        }
      }
      if ( main_is_more( "Goblin Guide",   3 ) &&
           main_is_more( "Lightning Bolt", 4 ) &&
           main_is_more( "Lava Spike",     3 ) ) {
        return "o[";
      }
      // more more more ...
      return "s";
    }
    return null
  }
}

::Organizer.special_entries.append( ModernArchetypeInferenceEntry() );
::Organizer.special_entries[::Organizer.special_entries.len() - 1].use = true;


// -- ^
// ȉ̋@\͂܂JiKɂȂ܂iRgOΓ܂j
// MO ̃fbLt@C̃^iƎǉdlj
// MO ̃fbLt@CɈȉ̂悤ȋLqΎ荞ŕ\ł悤ɂȂ܂B
//  : #PLAYER O
//      #TOURNAMENT_NAME 
class DeckHeaderEntry extends SpecialEntry {
  constructor( key ) {
    base.constructor( Card.Type.SideboardStart - 5000, "#" + key, "#" + key, Board.Type.Mainboard );
    this.key = key.toupper();
  }

  function case_of_cannot_process( processor ) {
    if ( processor instanceof DeckProcessor ) {
      if ( this.key in processor.deck.headers ) {
        return processor.deck.headers[key];
      }
    }
    return null
  }
  key = null;
}

::Organizer.special_entries.append( DeckHeaderEntry( "PLAYER" ) );
::Organizer.special_entries[::Organizer.special_entries.len() - 1].use = true;
::Organizer.special_entries.append( DeckHeaderEntry( "TOURNAMENT_NAME" ) );
::Organizer.special_entries[::Organizer.special_entries.len() - 1].use = true;
*/
